<?php

SDV($InlineReplacements['/\\[\\[\\$Gallery\\]\\]/e'], 'gallery()');

function gallery() {
	global $UploadDir;
	global $pagename;

	$pic = $_GET['pic'];
	$script = $_SERVER['PHP_SELF'];
	
	// Wiki-Werte einlesen
	$array = explode('.', $pagename);
	$path = $UploadDir.'/'.$array[0];
	$name = strtolower($array[1]);
	if (!is_dir($path)) return 'Noch keine Anhnge in dieser Gruppe vorhanden.';
	
	$path.= '/';
	$suffix = $name.'_';
	
	// Verzeichnis einlesen
	$dir = dir($path);
	while ($file = $dir->read()) {
		$filename = strtolower($file);
		if (!stristr($filename, 'thumb_') and stristr($filename, $suffix)) {
			if (stristr($filename, '.jpg')) {
				$image[] = $path.$filename;
				$thumbnail[] = $path.'thumb_'.$filename;
			}
			if (stristr($filename, '.png')) {
				$image[] = $path.$filename;
				$thumbnail[] = $path.'thumb_'.$filename;
			}
			if (stristr($filename, '.gif')) {
				$image[] = $path.$filename;
				$thumbnail[] = $path.'thumb_'.$filename;
			}
		}
	}
	$dir->close();

	$max = count($image);

	// Prfen on Bilder vorhanden sind
	if ($max == 0) return 'Es sind noch keine Bilder vorhanden.';

	// Inhaltsverzeichnis sortieren
	sort($image);
	sort($thumbnail);

	// Parameter prfen
	if (isset($pic)) {
		if ($pic > $max) $pic = $max;
		if ($pic < 1) $pic = 1;
	}

	if (!isset($pic)) {
		// Gallerie erzeugen
		echo '<div style="text-align:center">'."\n";
		for ($i = 0; $i < $max; $i++):
			if (!file_exists($thumbnail[$i])) gallery_createthumbnail($image[$i], $thumbnail[$i]);
			$size = getimagesize($thumbnail[$i]);
			echo '<a href="'.$script.'?pic='.($i+1).'" title="Bild #'.($i+1).'"><img class="thumb" src="/'.$thumbnail[$i].'" alt="Bild #'.($i+1).'" '.$size[3].' /></a>'."\n";
			flush();
		endfor;
		echo '</div>'."\n";
		flush();
	} else {
		// Einzelnes Bild anzeigen
		$size = getimagesize($image[$pic-1]);
		$title = 'Bild #'.$pic;

		echo '<div style="text-align:center">'."\n";
		gallery_navigation($pic, $max);
		echo '<br />'."\n";
		echo '<img class="photo" src="/'.$image[$pic-1].'" alt="Bild #'.($pic).' von '.$max.'" '.$size[3].' />'."\n";
		echo '<br />'."\n";
		echo '<small>Bild #'.$pic.' von '.$max.'</small>'."\n";
		echo '<br />'."\n";
		gallery_navigation($pic, $max);
		echo '</div>'."\n";
		flush();
	}
	return;
}


/**
 * Thumbnail erzeugen
 *
 * @param string $image Dateiname des Bildes
 * @param string $thumbnail Dateiname des Thumbnails
 */
function gallery_createthumbnail($image, $thumbnail) {
	// Infos ber Bild holen
	$info = getimagesize($image);
	$width = $info[0];
	$height = $info[1];
	$type = $info[2];

	// Thumbnail erstellen
	if ($type == 1) $new = imagecreatefromgif($image);
	elseif ($type == 2) $new = imagecreatefromjpeg($image);
	elseif ($type == 3) $new = imagecreatefrompng($image);

	$newwidth = 100;
	$newheight = $height/($width/$newwidth);
	$newimage = imagecreatetruecolor($newwidth, $newheight);
	imagecopyresampled($newimage, $new, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);

	if ($type == 1) imagegif($newimage, $thumbnail);
	elseif ($type == 2) imagejpeg($newimage, $thumbnail);
	elseif ($type == 3) imagepng($newimage, $thumbnail);
}


/**
 * Navigation anzeigen
 *
 * @param integer $pic Aktuelle Bild
 * @param integer $max Anzahl der Bilder
 * @return string
 */
function gallery_navigation($pic, $max) {
	$script = $_SERVER['PHP_SELF'];
	
	if ($pic > 1) {
		echo '<a href="'.$script.'?pic=1" title="Bild #1">&lt;&lt;</a>&nbsp;'."\n";
		echo '<a href="'.$script.'?pic='.($pic-1).'" title="Bild #'.($pic-1).'">&lt;</a>&nbsp;'."\n";
	} else {
		echo '&lt;&lt;&nbsp;'."\n";
		echo '&lt;&nbsp;'."\n";
	}

	echo '<a href="'.$script.'" title="&Uuml;bersicht">&Uuml;bersicht</a>&nbsp;'."\n";

	if ($pic < $max) {
		echo '<a href="'.$script.'?pic='.($pic+1).'" title="Bild #'.($pic+1).'">&gt;</a>&nbsp;'."\n";
		echo '<a href="'.$script.'?pic='.($max).'" title="Bild #'.($max).'">&gt;&gt;</a>'."\n";
	} else {
		echo '&gt;&nbsp;'."\n";
		echo '&gt;&gt;'."\n";
	}

	flush();
	
	return;
}
?>
